// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from hri_actions_msgs:msg/Intent.idl
// generated code does not contain a copyright notice

#ifndef HRI_ACTIONS_MSGS__MSG__DETAIL__INTENT__STRUCT_H_
#define HRI_ACTIONS_MSGS__MSG__DETAIL__INTENT__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'ENGAGE_WITH'.
/**
  * 'intent' constants
  * see table below for a short description of each.
 */
static const char * const hri_actions_msgs__msg__Intent__ENGAGE_WITH = "__intent_engage_with__";

/// Constant 'MOVE_TO'.
static const char * const hri_actions_msgs__msg__Intent__MOVE_TO = "__intent_move_to__";

/// Constant 'GUIDE'.
static const char * const hri_actions_msgs__msg__Intent__GUIDE = "__intent_guide__";

/// Constant 'GRAB_OBJECT'.
static const char * const hri_actions_msgs__msg__Intent__GRAB_OBJECT = "__intent_grab_object__";

/// Constant 'BRING_OBJECT'.
static const char * const hri_actions_msgs__msg__Intent__BRING_OBJECT = "__intent_bring_object__";

/// Constant 'PLACE_OBJECT'.
static const char * const hri_actions_msgs__msg__Intent__PLACE_OBJECT = "__intent_place_object__";

/// Constant 'GREET'.
static const char * const hri_actions_msgs__msg__Intent__GREET = "__intent_greet__";

/// Constant 'SAY'.
static const char * const hri_actions_msgs__msg__Intent__SAY = "__intent_say__";

/// Constant 'PRESENT_CONTENT'.
static const char * const hri_actions_msgs__msg__Intent__PRESENT_CONTENT = "__intent_present_content__";

/// Constant 'PERFORM_MOTION'.
static const char * const hri_actions_msgs__msg__Intent__PERFORM_MOTION = "__intent_perform_motion__";

/// Constant 'START_ACTIVITY'.
static const char * const hri_actions_msgs__msg__Intent__START_ACTIVITY = "__intent_start_activity__";

/// Constant 'STOP_ACTIVITY'.
static const char * const hri_actions_msgs__msg__Intent__STOP_ACTIVITY = "__intent_stop_activity__";

/// Constant 'WAKEUP'.
static const char * const hri_actions_msgs__msg__Intent__WAKEUP = "__intent_wakeup__";

/// Constant 'SUSPEND'.
static const char * const hri_actions_msgs__msg__Intent__SUSPEND = "__intent_suspend__";

/// Constant 'ROBOT_ITSELF'.
/**
  * 'source' constants:
  * for intents originating from the robot itself
 */
static const char * const hri_actions_msgs__msg__Intent__ROBOT_ITSELF = "__myself__";

/// Constant 'REMOTE_SUPERVISOR'.
/**
  * for intents originating from a external robot control system (for instance, a remote control tablet)
 */
static const char * const hri_actions_msgs__msg__Intent__REMOTE_SUPERVISOR = "__remote_supervisor__";

/// Constant 'UNKNOWN_AGENT'.
/**
  * for intents coming from an agent interacting with the robot, but not uniquely
  * identified
 */
static const char * const hri_actions_msgs__msg__Intent__UNKNOWN_AGENT = "__unknown_agent__";

/// Constant 'UNKNOWN'.
/**
  * for unknown sources
 */
static const char * const hri_actions_msgs__msg__Intent__UNKNOWN = "__unknown__";

/// Constant 'MODALITY_SPEECH'.
/**
  * 'modality' constants:
 */
static const char * const hri_actions_msgs__msg__Intent__MODALITY_SPEECH = "__modality_speech__";

/// Constant 'MODALITY_MOTION'.
/**
  * both gestures (eg waving) and displacement (eg approaching)
 */
static const char * const hri_actions_msgs__msg__Intent__MODALITY_MOTION = "__modality_motion__";

/// Constant 'MODALITY_TOUCHSCREEN'.
static const char * const hri_actions_msgs__msg__Intent__MODALITY_TOUCHSCREEN = "__modality_touchscreen__";

/// Constant 'MODALITY_OTHER'.
static const char * const hri_actions_msgs__msg__Intent__MODALITY_OTHER = "__modality_other__";

/// Constant 'MODALITY_INTERNAL'.
static const char * const hri_actions_msgs__msg__Intent__MODALITY_INTERNAL = "__modality_internal__";

// Include directives for member types
// Member 'intent'
// Member 'data'
// Member 'source'
// Member 'modality'
#include "rosidl_runtime_c/string.h"

/// Struct defined in msg/Intent in the package hri_actions_msgs.
/**
  * An intent is an abstract description of an operation to be performed by the
  * robot.
  *
  * While inspired by the Android intents
  * (https://developer.android.com/reference/android/content/Intent), ROS intents
  * are primarily designed to capture user-initiated intents. For instance, a
  * button click on a touchscreen, the result of a chatbot-based verbal
  * interaction, a command started by a remote user interface.
  *
  * Intents comprise of two mandatory fields: the `intent`, which should be one
  * of the available predefined intents, and the `data` which must be a JSON
  * object containing the data required to fully instantiate the intent.  While
  * the exact content of the JSON object is up to the application, the following
  * standard keys can be used to specify the intent's semantic roles (also called
  * thematic roles or theta roles):
  *
  * - `agent`: the agent expected to perform the intent (if omitted, the robot
  * itself is assumed)
  * - `object` (also named *theme* or *patient* in the linguistics literature): entity
  * undergoing the effect of the intent
  * - `goal`: entity towards which the intent is directed or moves
  * - `recipient`: entity that receives the object (denoted as the `theme`)
  *
  * Examples:
  *
  * - "I want you to go to the kitchen":
  *   - intent: `move_to`
  *   - data: {"goal":"kitchen_1"}
  *
  * - "Can you take the groceries to Luke in the kitchen?"
  *   - intent: `bring`
  *   - data: {"object": "groceries",
  *            "goal":"kitchen_1",
  *            "recipient": "person_luke"}
 */
typedef struct hri_actions_msgs__msg__Intent
{
  ///  Intent name
  ///
  /// A string describing the intent.
  ///
  /// Where suitable, the intent SHOULD be one of the constant defined below.
  /// However, we recognise that the list of intents is possibly large. Therefore,
  /// custom strings are also permissible. If you believe your intent name should
  /// be standardised and added to the list of pre-defined intents, fill the
  /// corresponding entry in the "thematic roles" table below and submit a pull
  /// request on this repository.
  rosidl_runtime_c__String intent;
  ///  Intent data
  ///
  /// a JSON object containing the data required to fully instantiate the intent.
  /// The keys of the object should be one of the thematic role defined above, or
  /// the general `other_data`.
  ///
  /// Each intent defines a specific set of required and optional thematic roles,
  /// listed in the following table (note that the `agent` role can be optionally
  /// added to all intents, and is omitted from the table for clarity):
  ///
  /// .. [please keep the RST table syntax below, as it is used to automatically parse the list of intents by some nodes]#
  /// .. BEGIN_INTENTS_TABLE
  /// +------------------+-----------------------------------------------------------------------------+-------------------------------------------------------------+---------------------------------------------------------------------------+
  /// | **Intent**       | **Description**                                                             | **Required thematic roles**                                 | **Optional thematic roles**                                               |
  /// +==================+=============================================================================+=============================================================+===========================================================================+
  /// | `ENGAGE_WITH`    | an agent wants to engage with another one                                   | - `recipient`                                               |                                                                           |
  /// +------------------+-----------------------------------------------------------------------------+-------------------------------------------------------------+---------------------------------------------------------------------------+
  /// | `MOVE_TO`        | navigates to a specific location                                            | - `goal`                                                    |                                                                           |
  /// +------------------+-----------------------------------------------------------------------------+-------------------------------------------------------------+---------------------------------------------------------------------------+
  /// | `GUIDE`          | guides someone somewhere                                                    | - `goal`                                                    |                                                                           |
  /// |                  |                                                                             | - `recipient`                                               |                                                                           |
  /// +------------------+-----------------------------------------------------------------------------+-------------------------------------------------------------+---------------------------------------------------------------------------+
  /// | `GRAB_OBJECT`    | pick-up a specific object                                                   | - `object`                                                  |                                                                           |
  /// +------------------+-----------------------------------------------------------------------------+-------------------------------------------------------------+---------------------------------------------------------------------------+
  /// | `BRING_OBJECT`   | bring a specific object to a specific place                                 | - `object`                                                  |                                                                           |
  /// |                  |                                                                             | - `recipient`                                               |                                                                           |
  /// +------------------+-----------------------------------------------------------------------------+-------------------------------------------------------------+---------------------------------------------------------------------------+
  /// | `PLACE_OBJECT`   | put an object on a support (eg a table)                                     | - `recipient`                                               | - `object` (only required if more that one object could be placed)        |
  /// +------------------+-----------------------------------------------------------------------------+-------------------------------------------------------------+---------------------------------------------------------------------------+
  /// | `GREET`          | greet an agent                                                              | - `recipient`                                               |                                                                           |
  /// +------------------+-----------------------------------------------------------------------------+-------------------------------------------------------------+---------------------------------------------------------------------------+
  /// | `SAY`            | says some text, optionally annotated with gestures or expressions           | - `object` (the text to say)                                | - `recipient`                                                             |
  /// +------------------+-----------------------------------------------------------------------------+-------------------------------------------------------------+---------------------------------------------------------------------------+
  /// | `PRESENT_CONTENT`| present (via a screen, pre-recorded text...) predefined content             | - `object` (the content identifier)                         | - `recipient`                                                             |
  /// +------------------+-----------------------------------------------------------------------------+-------------------------------------------------------------+---------------------------------------------------------------------------+
  /// | `PERFORM_MOTION` | performs a motion (eg, a dance or a specific gesture like pointing, waving) | - `object` (the system-specific name of the motion/gesture) | - `recipient`                                                             |
  /// +------------------+-----------------------------------------------------------------------------+-------------------------------------------------------------+---------------------------------------------------------------------------+
  /// | `START_ACTIVITY` | start a scripted behaviour/activity                                         | - `object` (the name of the activity)                       | - any additional parameter required to start the activity                 |
  /// +------------------+-----------------------------------------------------------------------------+-------------------------------------------------------------+---------------------------------------------------------------------------+
  /// | `STOP_ACTIVITY`  | request cancelation of an activity                                          |                                                             | - `object` (the name of the activity. If unset, current main activity)    |
  /// +------------------+-----------------------------------------------------------------------------+-------------------------------------------------------------+---------------------------------------------------------------------------+
  /// | `WAKEUP`         | request reactivation of the system                                          |                                                             |                                                                           |
  /// +------------------+-----------------------------------------------------------------------------+-------------------------------------------------------------+---------------------------------------------------------------------------+
  /// | `SUSPEND`        | request suspension of the system                                            |                                                             |                                                                           |
  /// +------------------+-----------------------------------------------------------------------------+-------------------------------------------------------------+---------------------------------------------------------------------------+
  /// .. END_INTENTS_TABLE
  rosidl_runtime_c__String data;
  ///  Intent source
  ///
  /// a string describing the source of the intent. This is *not* the node
  /// which published the intent, but instead the actual agent who expressed the
  /// intent/command/desire.
  /// `source` can be either one of the constant below, or the specific id of the
  /// person/agent expressing the intent. In a REP-155 compliant system, this ID
  /// must be the person ID of the agent.
  rosidl_runtime_c__String source;
  ///  Intent modality
  ///
  /// modality used to originally convey the intent: verbal, via the touchscreen,
  /// via a gesture...
  /// The special modality MODALITY_INTERNAL must be used for intents coming for the
  /// robot's internal processes (eg 'battery low, I need to charge')
  /// MUST be one of the MODALITY_ constant below.
  rosidl_runtime_c__String modality;
  ///  Intent priority
  ///
  /// the priority of this intent. This MIGHT be used as a hint by the robot's task
  /// scheduler, however is scheduler is *not* forced to respect this priority
  /// level. 0 is the lowest priority, 128 is the default priority, 255 is the
  /// highest priority.
  uint8_t priority;
  ///  Intent confidence
  ///
  /// a value between 0.0 (no confidence) and 1.0 (full confidence) that the intent
  /// was correctly perceived and interpreted.
  ///
  /// For instance, a 'waving' gesture could be interpreted as an implicit request
  /// from a user for the robot to greet back or engage. As this interpretation is
  /// not certain, the confidence of the intent may be below 1.0.
  float confidence;
} hri_actions_msgs__msg__Intent;

// Struct for a sequence of hri_actions_msgs__msg__Intent.
typedef struct hri_actions_msgs__msg__Intent__Sequence
{
  hri_actions_msgs__msg__Intent * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} hri_actions_msgs__msg__Intent__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // HRI_ACTIONS_MSGS__MSG__DETAIL__INTENT__STRUCT_H_
